
-- Date August,2017
-- Copyright (C) Slavo LS Modding; edited tatti14


rda = {};

function rda.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function rda:load(xmlFile)
	self.cu = false;
	self.uvg = false;
	self.m = 1;
		
	self.variogrip = true;
	self.hasVarioGrip = true;

	
	self.suspFront = self.wheels[1].suspTravel;
	self.suspBack = self.wheels[3].suspTravel;

	self.deformFront = self.wheels[1].maxDeformation;
	self.deformBack = self.wheels[3].maxDeformation;

	self.frictionFront = self.wheels[1].frictionScale;
	self.frictionBack = self.wheels[3].frictionScale;
end;

function rda:delete()
end;

function rda:readStream(streamId, connection)
end;

function rda:writeStream(streamId, connection)
end;

function rda:mouseEvent(posX, posY, isDown, isUp, button)
end;

function rda:keyEvent(unicode, sym, modifier, isDown)
end;

function rda:update(dt)
	
	if self.isMotorStarted then
		if(self.seatSusp) then
			setTranslation(self.seatID, self.startSeatXTranslation, self.startSeatYTranslation+self.wheels[4].deltaY, self.startSeatZTranslation);
		end;

		if InputBinding.hasEvent(InputBinding.VarioGrip) then
			if (self.hasVarioGrip) then
				self.variogrip = not self.variogrip;
				self.uvg = true;
				if (self.variogrip) then t = 5; else t = 1; end;
			end;
		end;

		if(self.uvg == true) then
		    for i, wheel in ipairs(self.wheels) do
		    	if(self.variogrip) then

		    		if(self.deformFront*t > wheel.maxDeformation) then
		    			self.m = self.m+0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel - (self.m / 10000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
			    	else
			    		self.uvg = false;
		    		end;
		    	else
		    		if(self.deformFront*t < wheel.maxDeformation) then
		    			self.m = self.m-0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel + (self.m / 10000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
		    		else 
						self.uvg = false;
		    		end;
		    	end;
			end;

		end;
	end;

end;



function rda:draw()
end;

function rda:onLeave()
end;

function rda:onEnter()
end;